/* USBasp main.c */
/* ̉ǂ́Airuka񂪍s܂
   2008N912`922
   2008N922 eXgJJn
 */

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <util/delay.h>

#include "usbdrv.h"

/* ------------------------------------------------------------------------- */

#define	INCLUDE_MONITOR_CMD	0	// 62:POKE(),63:PEEK().
#define	INCLUDE_LED_CMD		0	// 02:LEDR}h.

/* ------------------------------------------------------------------------- */

#define	ID1	   1
#define	ID2	   2
#define	ID3	   3

#define	SIZE1  8
#define	SIZE2 40
#define	SIZE3 72

PROGMEM	char usbHidReportDescriptor[42]	= {
	0x06, 0x00,	0xff,			   // USAGE_PAGE (Generic Desktop)
	0x09, 0x01,					   // USAGE	(Vendor	Usage 1)
	0xa1, 0x01,					   // COLLECTION (Application)
	0x15, 0x00,					   //	LOGICAL_MINIMUM	(0)
	0x26, 0xff,	0x00,			   //	LOGICAL_MAXIMUM	(255)
	0x75, 0x08,					   //	REPORT_SIZE	(8)

	0x85, 0x01,					   //	REPORT_ID (1)
	0x95, 0x06,					   //	REPORT_COUNT (6)
	0x09, 0x00,					   //	USAGE (Undefined)
	0xb2, 0x02,	0x01,			   //	FEATURE	(Data,Var,Abs,Buf)

	0x85, 0x02,					   //	REPORT_ID (2)
	0x95, 0x26,					   //	REPORT_COUNT (38)
	0x09, 0x00,					   //	USAGE (Undefined)
	0xb2, 0x02,	0x01,			   //	FEATURE	(Data,Var,Abs,Buf)

	0x85, 0x03,					   //	REPORT_ID (3)
	0x95, 0x46,					   //	REPORT_COUNT (70)
	0x09, 0x00,					   //	USAGE (Undefined)
	0xb2, 0x02,	0x01,			   //	FEATURE	(Data,Var,Abs,Buf)

	0xc0						   // END_COLLECTION
};
/* Note: REPORT_COUNT does not include report-ID byte */


//
//	Mobt@.
//
typedef struct {
	uchar id[1];
	uchar buf[8];	//buf[8] ́AʒuƂĎgƂ8oCg܂.
} ResultBuf_t;		//AAReportID=1upƂ6oCgMȂ̂Œ.

static ResultBuf_t result;
#define	usbData result.buf
#define	buffer  result.id


//
//	Mobt@.
//
static uchar bytesRemaining; // Receive Data Pointer
static uchar pktCount;		// pPbgJE^.
static uchar wrCount;		// ݃oCgJE^.
static uchar report_id;		// NXNGXg	HID	Report ID
static uchar    page_mode;
static uint16_t	page_addr;

//
#if	INCLUDE_MONITOR_CMD

//	[ǂݏR}h\.
typedef	struct {
	uchar hidasp_cmd;	// 62=poke 63=peek
	uchar count;		// ǂݍ݃oCg.
	uchar *addr;		// ǂݏAhX.
	uchar memdata[2];	// ǂݍ݃f[^. ͏݃f[^[0] }XN[1]
} MonCommand_t;
//	:̃o[Wȍ~ł͓ǂݏoTCY4oCgɐ.
//	ReportLENGTH=6ł邽.

static void	cmd_poke(MonCommand_t *cmd)
{
	uchar *p=cmd->addr;
	if(cmd->memdata[1])	{	//}XNt̏.
		*p = (*p & cmd->memdata[1])	| cmd->memdata[0];
	}else{			//ׂ.
		*p = cmd->memdata[0];
	}
}
static void	cmd_peek(MonCommand_t *cmd)
{
	uchar i;
	uchar *p=cmd->addr;
	for(i=0;i<(cmd->count);i++)	{
		usbData[i]=*p++;
	}
}
#endif


// œKp
#define	hbyte(a) (*((uchar*)&(a)+1))
#define	lbyte(a) (*((uchar*)&(a)))
inline static uint8_t byte(uint8_t t) {return t;}

static void	delay(uchar	d) {
	do {	// 4clock loop = 0.33usec *	N
		asm("nop");
		asm("nop");
	} while(d--);
}
static uint8_t wait=60;	// 160

static uint8_t usi_trans(uint8_t data){
	USIDR=data;
	USISR=(1<<USIOIF);
	do{
//		delay(wait);
		USICR=(1<<USIWM0)|(1<<USICS1)|(1<<USICLK)|(1<<USITC);
	} while(!(USISR&(1<<USIOIF)));
	return USIDR;
}

static inline void isp_command(uint8_t *data){
	int	i;
	for	(i=0;i<4;i++) {
		usbData[i]=usi_trans(data[i]);
	}
}

void page_trans(uchar *data,uchar cnt)
{
	uchar i;
	for(i=0;i<cnt;i++) {
		usi_trans(page_mode);
		usi_trans(hbyte(page_addr));
		usi_trans(lbyte(page_addr));
		usbData[i]=usi_trans(data[i]);
		if (page_mode & 0x88) { // EEPROM or FlashH
			page_addr++;
			page_mode&=~0x08;
		} else {
			page_mode|=0x08;
		}
	}
}

/* ------------------------------------------------------------------------- */
/* ----------------------------- execute Buffer	---------------------------- */
/* ------------------------------------------------------------------------- */
//
//		hidasp̃C.
//

#define	HIDASP_TEST	      1
#define	HIDASP_SET_STATUS 2
#define	HIDASP_CMD_TX    16
#define	HIDASP_SET_PAGE	 20
#define	HIDASP_PAGE_TX   22
#define	HIDASP_SET_DELAY 60
#define	HIDASP_POKE	     62
#define	HIDASP_PEEK	     63

void hidasp_main(uchar *data)
{
	uint8_t	data0 =	data[0];
	uint8_t	data1 =	data[1];
	uint8_t	cmd	  =	data0 &	0xfe;

	if ( data[0] ==	HIDASP_TEST	) {	// TEST
		usbData[0] = data1;
	}
#if	INCLUDE_LED_CMD
	else if	( data0	== HIDASP_SET_STATUS ) { //	SET_LED
		PORTD =	(PORTD&~3)	  |	(data1   & 3);
//		PORTB =	(PORTB&~0x10) |	(data[2] & 0x1F);
		// RESETsێAȊOORo
		PORTB =	(PORTB&~0x1F) |	(data[2]&0x1f) ;
	}
#endif
	else if	( cmd == HIDASP_CMD_TX)	{ // SPI
		isp_command(data+1);
	} else if (	data0 == HIDASP_SET_PAGE ) { //	Page set
		page_mode =	data1;
		page_addr =	0;
	} else if (	cmd	== HIDASP_PAGE_TX )	{ // Page buf
		if(data1>=5) {data1=5;}		// [id] [cmd] [len] data[5]
		page_trans(data+2,data1);
		wrCount -= data1;		// c菑݃oCg.
	} else if (	data0 == HIDASP_SET_DELAY )	{ // Set wait
		wait=data1;
	}
#if	INCLUDE_MONITOR_CMD
	else if	( data0	== HIDASP_POKE ) {
		cmd_poke((MonCommand_t *)data);
	} else if (	data0 == HIDASP_PEEK ) {
		cmd_peek((MonCommand_t *)data);
	}
#endif
}


/* ------------------------------------------------------------------------- */
/* ----------------------------- USB interface ----------------------------- */
/* ------------------------------------------------------------------------- */

// ftHgȊO	usb	setup R}hpPbgŉ߂.
uchar usbFunctionSetup(uchar data[8])
{
	usbRequest_t	*rq	= (void	*)data;
	uchar			rqType = rq->bmRequestType & USBRQ_TYPE_MASK;
	if(rqType == USBRQ_TYPE_CLASS){	   /* class	request	type */
		if((rq->bRequest ==	USBRQ_HID_GET_REPORT )
		||(	rq->bRequest ==	USBRQ_HID_SET_REPORT ))	{
			report_id =	rq->wValue.bytes[0];	/* store report	ID */
			pktCount = 0;						// packet sequence count
			bytesRemaining = rq->wLength.word;	// store the amount	of data	requested

			// Z GetReport  result Ԃ. (OSetReportŃR}hs)
			if((bytesRemaining < 8 ) &&
			   (rq->bRequest == USBRQ_HID_GET_REPORT )) {
				result.id[0]=ID1;
				usbMsgPtr = result.id;
				return 7;
			}
			return 0xff;						// tell	driver to use usbFunctionWrite()
		}
	}
	return 0;
}


// Rg[]㑱f[^ĂꍇA8oCgPʂŎ󂯎.
//	Eʂreport\̂ɓ.
//	ES󂯎Ahidasp_main()Ăяo.
uchar usbFunctionWrite(uchar *data,	uchar len)
{
	// ŏ̃pPbg̏ꍇ.
	if (pktCount == 0) {
		wrCount = data[2];	// [id] [cmd] [count]
		// ZR}h́Ahidasp_main()ɔC.
		hidasp_main(data+1);
	}

	//R}h̑s.
	// [ ID ] [ cmd ] [ size ] [ data ... (32byte  64byte) ]

	if(	len	> bytesRemaining) {				// if this is the last incomplete chunk
		len	= bytesRemaining;				// limit to	the	amount we can store
	}
	bytesRemaining -= len;

	if(	len	> wrCount) {
		len	= wrCount;	
	}

	if((pktCount != 0)&&(len)) {
		page_trans(data,len);
		wrCount -= len;		// c菑݃oCg.
	}

	pktCount++;

	// S󂯎A1 Ԃ.
	if(	bytesRemaining == 0	) {
		return 1;	// return 1	if we have all data
	}
	return 0;		// continue	data.
}


// Rg[]foCX̌㑱f[^vĂꍇA8oCgPʂő.
//	R}h
// 		[ ID ] [ data ... (32byte  64byte) ]
uchar usbFunctionRead(uchar *data, uchar len)
{
	uchar i;
	uchar l;
    if(	len > bytesRemaining)               // len is max chunk size
        len = bytesRemaining;               // send an incomplete chunk
    bytesRemaining -= len;

	l = len;
	if( pktCount == 0) {					//ŏ̃pPbg.
		data[0] = report_id;				//NXNGXgRs[.
		data++;l--;							//̂VoCgf[^Ŗ߂.
	}else{
		if(l!=8) l = 1;
	}

	page_trans(data,l);
	for(i =	0; i < l; i++) {
		data[i] = usbData[i];			//page_tranšʂRs[.
	}

	pktCount++;
    return len;                             // return real chunk size
}

/*
	   ATtiny2313
	   ___	  ___
RESET [1  |__| 20]Vcc
	  [2	   19]PB7(SCK)
	  [3	   18]PB6(MISO)
XTAL2 [4	   17]PB5(MOSI)
XTAL1 [5	   16]PB4(RST)
	  [6	   15]
PD3	  [7	   14]
PD4	  [8	   13]
	  [9	   12]
GND	  [10	   11]
	   ~~~~~~~~~~

   ---------------------------------------
   SPI:		PB7-4 ===> [Target AVR Device]
   USB:		PD3	  ===> USB D+
			PD4	  ===> USB D-
   XTAL:	XTAL1,2	=> Crystal 12MHz
   ---------------------------------------
*/

int	main(void)
{
//	USB	D+ D- ̔zrl̐VH}p HIDsphƂ݊Ȃ̂ł𐄏.
	DDRD = ~USBMASK;   /* all outputs except USB data */
//	PORTB =	(1<<4)|(1<<3);	/* RESET=High, PB3 LED(PWR)	ON,	PB2	LED(ACC) OFF */
	DDRB = ~(1<<5);	   /* all outputs except USI input data	*/
	USICR=(1<<USIWM0)|(1<<USICS1)|(1<<USICLK);

	usbInit();
	sei();
	for(;;){	/* main	event loop */
		usbPoll();
	}
	return 0;
}
